import { IAnimateOption, IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class FillModel extends BaseModel {
    meter2coord: number;
    private isMeter;
    getUninforms(): IModelUniform;
    getAnimateUniforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(): IModel[];
    /**
     * 计算等面积点图层（unit meter）笛卡尔坐标标度与世界坐标标度的比例
     * @returns
     */
    calMeter2Coord(): void;
    buildModels(): IModel[];
    /**
     * 根据 animateOption 的值返回对应的 shader 代码
     * @returns
     */
    getShaders(animateOption: IAnimateOption): {
        frag: string;
        vert: string;
        type: string;
    };
    clearModels(): void;
    protected animateOption2Array(option: IAnimateOption): number[];
    protected registerBuiltinAttributes(): void;
}
